Super Jumping! Jumping! Jumping!
Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.
The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
Output
For each case, print the maximum according to rules, and one line one case.
Sample Input
3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
Sample Output
4 10 3
Author
lcy
【分析】此题应该用DP解决,每个位置都有一个最大和,在此第n个位置的前面n-1个位置中选最接近a[n]且要小于a[n]的那个位置的最大和再加上a[n],就得到第n个位置的最大和,然后再找出所以位置中的最大和,就是所要的答案!
状态转移方程为:dp[i] = max(dp[j]+a[i]),1 <=j<i;
AC代码:
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int main()
{
int n, a[1005];
int dp[1005];//记录当前位置j的最优解
while(scanf("%d", &n) != EOF, n)
{
memset(dp, 0, sizeof(dp));
memset(a, 0, sizeof(a));
for(int i = 1; i <= n; i++)
scanf("%d", &a[i]);
int maxn = -1;
for(int i = 1; i <= n; i++)
{
int temp = 0;
for(int j = i-1; j >= 0; j--)
if(a[i] > a[j] && temp < dp[j])
temp=dp[j];//i前面的位置中,既满足a[i]>a[j]又满足是dp[j]中的最大值
dp[i] += a[i] + temp;//本位置最大和dp[i]=当前位置a[i]+位置i前最大位置的和
maxn = max(maxn, dp[i]);//寻求最大和
}
printf("%d\n", maxn);
}
return 0;
}